#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>


#define N 4


bool is_normalised(const int **mat, const int side) {
	for (int i = 0; i < side; ++i) {
		const int norm = i + 1;
		if (mat[0][i] != norm) { return false; }
		if (mat[i][0] != norm) { return false; }
		bool inrow[side];
		bool incol[side];
		for (int k = 0; k < side; ++k) {
			inrow[k] = false;
			incol[k] = false;
		}
		for (int k = 0; k < side; ++k) {
			// check rows
			const int r = mat[i][k] - 1;
			if (r < 0 || r >= side) { return false; }
			if (inrow[r]) { return false; }
			else { inrow[r] = true; }
			// check columns
			const int c = mat[k][i] - 1;
			if (c < 0 || c >= side) { return false; }
			if (incol[c]) { return false; }
			else { incol[c] = true; }
		}
	}
	return true;
}


int main() {
	int **mat;
	mat = malloc(N * sizeof(int*));
	for (int i = 0; i < N; ++i) { mat[i] = malloc(N * sizeof(int)); }
	for (int row = 0; row < N; ++row) {
		for (int col = 0; col < N; ++col) {
			scanf("%d", &(mat[row][col]));
		}
	}
	if (is_normalised((const int**) mat, N)) {
		printf("\nlatin normalise: oui\n\n");
	}
	else {
		printf("\nlatin normalise: non\n\n");
	}
	for (int i = 0; i < N; ++i) { free(mat[i]); }
	free(mat);
	return 0;
}
